<?php

namespace InGeKurs\KursStructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Exkursion KursStructType
 * @subpackage Structs
 */
class Exkursion extends AbstractStructBase
{
    /**
     * The datum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $datum;
    /**
     * The ziel
     * Meta information extracted from the WSDL
     * - documentation: Länge zwischen 20 bis 100 Zeichen. Erst ab Stichtag verpflichtend.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ziel;
    /**
     * Constructor method for Exkursion
     * @uses Exkursion::setDatum()
     * @uses Exkursion::setZiel()
     * @param string $datum
     * @param string $ziel
     */
    public function __construct($datum = null, $ziel = null)
    {
        $this
            ->setDatum($datum)
            ->setZiel($ziel);
    }
    /**
     * Get datum value
     * @return string
     */
    public function getDatum()
    {
        return $this->datum;
    }
    /**
     * Set datum value
     * @param string $datum
     * @return \InGeKurs\KursStructType\Exkursion
     */
    public function setDatum($datum = null)
    {
        // validation for constraint: string
        if (!is_null($datum) && !is_string($datum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datum, true), gettype($datum)), __LINE__);
        }
        $this->datum = $datum;
        return $this;
    }
    /**
     * Get ziel value
     * @return string|null
     */
    public function getZiel()
    {
        return $this->ziel;
    }
    /**
     * Set ziel value
     * @param string $ziel
     * @return \InGeKurs\KursStructType\Exkursion
     */
    public function setZiel($ziel = null)
    {
        // validation for constraint: string
        if (!is_null($ziel) && !is_string($ziel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ziel, true), gettype($ziel)), __LINE__);
        }
        $this->ziel = $ziel;
        return $this;
    }
}
