<?php

namespace InGeKurs\KursStructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KursIdentifikation KursStructType
 * @subpackage Structs
 */
class KursIdentifikation extends AbstractStructBase
{
    /**
     * The kennung
     * Meta information extracted from the WSDL
     * - documentation: Die vom BAMF bei der Ersterfassung der Planung vergebene Kennung des Kurses.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $kennung;
    /**
     * Constructor method for KursIdentifikation
     * @uses KursIdentifikation::setKennung()
     * @param string $kennung
     */
    public function __construct($kennung = null)
    {
        $this
            ->setKennung($kennung);
    }
    /**
     * Get kennung value
     * @return string
     */
    public function getKennung()
    {
        return $this->kennung;
    }
    /**
     * Set kennung value
     * @param string $kennung
     * @return \InGeKurs\KursStructType\KursIdentifikation
     */
    public function setKennung($kennung = null)
    {
        // validation for constraint: string
        if (!is_null($kennung) && !is_string($kennung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kennung, true), gettype($kennung)), __LINE__);
        }
        $this->kennung = $kennung;
        return $this;
    }
}
